﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 

	#FullScreen: False
	#IncludeTitle: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private XUI As XUI

	Type ItemValue (rtnReceiptID As String)
	
	Public strSelectedReceiptID As String
	Public bolDeletedReceipt As Boolean
	Public bolReceiptDateUpdated As Boolean
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
		
	'v0.1  (17/05/2020) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label

	Private clvPanel As CustomListView
	
	Private intSelectedIndex As Int
	Private strReceiptDateFirst As String
	Private strReceiptDateFirstYYMM As String
	Private strReceiptDateLast As String
	Private strReceiptDateLastYYMM As String
	Private strReceiptDateFromYYMM As String
	Private strReceiptDateSearchYYMM As String
	Private intMM As Int
	Private intYY As Int
	Private tblMonth(13) As String

	Private lblReceiptID As Label
	Private lblReceiptDate As Label
	Private lblRetailerName As Label
	Private lblReceiptAmount As Label
	Private lblStoreChargeName As Label
	Private lblReceiptClaimID As Label
	Private lblReceiptNotes As Label
	Private pnlPhoto As Panel
	Private imgPhoto As ImageView
	
	Private ECReceiptSet As ResultSet

	Private outReceiptID As String
	Private outReceiptDate As String
	Private outRetailerName As String
	Private outReceiptAmount As String
	Private outStoreChargeName As String
	Private outReceiptClaimID As String
	Private outReceiptNotes As String
	
	Private intReceiptRetailerID As Int
	Private strReceiptDate As String
	Private intReceiptAmount As Int
	Private dblReceiptAmount As Double
	Private strStoreChargeID As String
	
	Private lblPrev As Label
	Private lblMonth As Label
	Private lblNext As Label
	Private lblBack As Label
		
	Private strSQLQuery As String
	
	Private strNothing As String = ""
	Private int0 As Int = 0
	Private intReceiptNumber As Int
		
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	SetupMonthTable
	
	bolReceiptDateUpdated = False

	Activity.LoadLayout("ECS20")
	
	lblVersion.Text = strVersion
	
	intSelectedIndex = int0
	
	SelectReceiptFirst
	SelectReceiptLast

	strReceiptDateFromYYMM = strReceiptDateFirstYYMM
	
End Sub

Sub Activity_Resume

	If bolReceiptDateUpdated = True Then
		SelectReceiptFirst
		SelectReceiptLast
	End If
		
	SelectReceiptList

	intMM = strReceiptDateFromYYMM.SubString2(2, 4)
	intYY = strReceiptDateFromYYMM.SubString2(0, 2)
	
	FormatMonthLabel

	If bolDeletedReceipt = True Then
		If intSelectedIndex > int0 Then
			intSelectedIndex = intSelectedIndex - 1
		End If
	End If
	clvPanel.JumpToItem(intSelectedIndex)
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	Log ("index first " & clvPanel.FirstVisibleIndex)
	Log ("index last  " & clvPanel.LastVisibleIndex)

	intSelectedIndex = clvPanel.FirstVisibleIndex
	Log (" value " & clvPanel.GetValue(intSelectedIndex))

End Sub

Sub CreateItem As B4XView

	Dim p As B4XView = XUI.CreatePanel("")
	
	p.SetLayoutAnimated(0, 0, 0, 100%x, 163dip)
	p.LoadLayout("ECS20clv")
	
	intReceiptNumber = outReceiptID.SubString(4)
	lblReceiptID.Text = intReceiptNumber
	lblReceiptDate.Text = outReceiptDate
	lblRetailerName.Text = outRetailerName
	SetEllipsize(lblRetailerName, "END")
	lblReceiptAmount.Text = outReceiptAmount
	If dblReceiptAmount < int0 Then
		lblReceiptAmount.TextColor = Colors.Green
	Else
		lblReceiptAmount.TextColor = Colors.Yellow
	End If
	lblStoreChargeName.Text = outStoreChargeName
	SetEllipsize(lblStoreChargeName, "END")
	lblReceiptClaimID.Text = outReceiptClaimID
	lblReceiptNotes.Text = outReceiptNotes
	SetEllipsize(lblReceiptNotes, "END")
	lblReceiptNotes.BringToFront
	pnlPhoto.SetBackgroundImage(LoadBitmapSample(ECS00.PhotoFolder, _
		outReceiptID & ".jpg", 120dip, 140dip).Rotate(90))

	Return p
	
End Sub

Sub SetEllipsize(TextView As Label, Mode As String)
	
	Dim r As Reflector
	r.Target = TextView
	r.RunMethod2("setLines", 1, "java.lang.int")
	r.RunMethod2("setHorizontallyScrolling", True, "java.lang.boolean")
	r.RunMethod2("setEllipsize", Mode, "android.text.TextUtils$TruncateAt")
	
End Sub

'SELECT DATABASE CALLS
'=====================

Sub SelectReceiptFirst
	
	strSQLQuery = "Select ReceiptDate FROM Receipt "
	strSQLQuery = strSQLQuery & " ORDER BY ReceiptDate ASC"
	
	strReceiptDateFirst = ECS00.SQLEC.ExecQuerySingleResult(strSQLQuery)
	
	strReceiptDateFirstYYMM = strReceiptDateFirst.SubString2(0,4)
	
End Sub

Sub SelectReceiptLast
	
	strSQLQuery = "Select ReceiptDate FROM Receipt "
	strSQLQuery = strSQLQuery & " ORDER BY ReceiptDate DESC"
	
	strReceiptDateLast = ECS00.SQLEC.ExecQuerySingleResult(strSQLQuery)

	strReceiptDateLastYYMM = strReceiptDateLast.SubString2(0,4)

End Sub

Sub SelectReceiptList

	strReceiptDateSearchYYMM = strReceiptDateFromYYMM
	
	If strReceiptDateSearchYYMM = strReceiptDateFirstYYMM Then
		lblPrev.Visible = False
		lblPrev.Enabled = False
	Else
		lblPrev.Visible = True
		lblPrev.Enabled = True
	End If
	
	If strReceiptDateSearchYYMM = strReceiptDateLastYYMM Then
		lblNext.Visible = False
		lblNext.Enabled = False
	Else
		lblNext.Visible = True
		lblNext.Enabled = True
	End If
	
	strReceiptDateSearchYYMM = strReceiptDateSearchYYMM & "%"
	strSQLQuery = "Select * FROM Receipt WHERE ReceiptDate LIKE ?  ORDER BY ReceiptID DESC"
	
	ECReceiptSet = ECS00.SQLEC.ExecQuery2(strSQLQuery, _
		Array As String(strReceiptDateSearchYYMM))

	clvPanel.Clear
	clvPanel.sv.Visible = False
	
	Log ("Start " & DateTime.Now)
	Do While ECReceiptSet.NextRow
		outReceiptID = ECReceiptSet.GetString("ReceiptID")
		strReceiptDate = ECReceiptSet.GetString("ReceiptDate")
		outReceiptDate = strReceiptDate.SubString2(4, 6) & "/" & strReceiptDate.SubString2(2, 4)
		outReceiptDate = outReceiptDate & "/" & strReceiptDate.SubString2(0, 2)
		intReceiptRetailerID = ECReceiptSet.GetInt("ReceiptRetailerID")
		SelectRetailerName
		dblReceiptAmount = ECReceiptSet.GetDouble("ReceiptAmount")
		intReceiptAmount = dblReceiptAmount
		If dblReceiptAmount = intReceiptAmount Then
			outReceiptAmount = dblReceiptAmount & ".00"
		Else
			outReceiptAmount = dblReceiptAmount
		End If
		If outReceiptAmount.CharAt(outReceiptAmount.Length - 2) = "." Then
			outReceiptAmount = outReceiptAmount & "0"
		End If
		strStoreChargeID = ECReceiptSet.GetString("ReceiptChargeStoreID")
		SelectStoreName
		outReceiptNotes = ECReceiptSet.GetString("ReceiptNotes")
		outReceiptClaimID = ECReceiptSet.GetInt("ReceiptClaimID")
		If outReceiptClaimID = "0" Then
			outReceiptClaimID = strNothing
		Else
			outReceiptClaimID = outReceiptClaimID & "." & ECReceiptSet.GetInt("ReceiptClaimPart")
		End If
		clvPanel.Add(CreateItem, outReceiptID)
	Loop
	ProgressDialogHide
	Log ("End " & DateTime.Now)
	
	clvPanel.sv.Visible = True
	
End Sub

Sub SelectRetailerName
		
	strSQLQuery = "Select RetailerName FROM Retailer WHERE RetailerID = ?"
	
	outRetailerName = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intReceiptRetailerID))
	
End Sub

Sub SelectStoreName
	
	strSQLQuery = "Select StoreName FROM Store WHERE StoreID = ?"
	
	outStoreChargeName = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(strStoreChargeID))
		
End Sub

'CLICK EVENTS
'============

Sub clvPanel_ItemClick (Index As Int, Value As Object)
	
	intSelectedIndex = Index
	strSelectedReceiptID = Value
	bolDeletedReceipt = False
	bolReceiptDateUpdated = False
	
	StartActivity(ECS21)
	
End Sub

Sub lblPrev_Click
	
	intMM = strReceiptDateFromYYMM.SubString2(2, 4)
	intYY = strReceiptDateFromYYMM.SubString2(0, 2)
	
	intMM = intMM - 1
	If intMM = int0 Then
		intMM = 12
		intYY = intYY - 1
	End If
		
	If intMM < 10 Then
		strReceiptDateFromYYMM = intYY & "0" & intMM
	Else
		strReceiptDateFromYYMM = intYY & intMM
	End If
	
	SelectReceiptList
	
	Do Until ECReceiptSet.RowCount > 0
		intMM = intMM - 1
		If intMM = int0 Then
			intMM = 12
			intYY = intYY - 1
		End If
		If intMM < 10 Then
			strReceiptDateFromYYMM = intYY & "0" & intMM
		Else
			strReceiptDateFromYYMM = intYY & intMM
		End If
		SelectReceiptList
	Loop

	FormatMonthLabel

End Sub

Sub lblNext_Click
	
	intMM = strReceiptDateFromYYMM.SubString2(2, 4)
	intYY = strReceiptDateFromYYMM.SubString2(0, 2)
	
	intMM = intMM + 1
	If intMM = 13 Then
		intMM = 1
		intYY = intYY + 1
	End If
	
	If intMM < 10 Then
		strReceiptDateFromYYMM = intYY & "0" & intMM
	Else
		strReceiptDateFromYYMM = intYY & intMM
	End If

	SelectReceiptList
	
	Do Until ECReceiptSet.RowCount > 0
		intMM = intMM + 1
		If intMM = 13 Then
			intMM = 1
			intYY = intYY + 1
		End If
		If intMM < 10 Then
			strReceiptDateFromYYMM = intYY & "0" & intMM
		Else
			strReceiptDateFromYYMM = intYY & intMM
		End If
		SelectReceiptList
	Loop

	FormatMonthLabel

End Sub

Sub lblBack_Click
	
	Activity.Finish

End Sub

'GENERAL ROUTINES
'================

Sub FormatMonthLabel
	
	Select intMM
		Case 2, 9, 11, 12
			lblMonth.Padding = Array As Int(0dip, -3dip, 0dip, 0dip)
		Case Else
			lblMonth.Padding = Array As Int(0dip, 0dip, 0dip, 0dip)
	End Select

	lblMonth.Text = tblMonth(intMM) & intYY

End Sub

'INITIALISATION ROUTINES
'=======================

Sub SetupMonthTable
	
	tblMonth(1) = "January 20"
	tblMonth(2) = "February 20"
	tblMonth(3) = "March 20"
	tblMonth(4) = "April 20"
	tblMonth(5) = "May 20"
	tblMonth(6) = "June 20"
	tblMonth(7) = "July 20"
	tblMonth(8) = "August 20"
	tblMonth(9) = "September 20"
	tblMonth(10) = "October 20"
	tblMonth(11) = "November 20"
	tblMonth(12) = "December 20"
		
End Sub